package ja.webclient.beans.jaasset;

package ..deTemp.1731565211019;

import ja.app.common.dto.AssetDto;
import ja.app.util.ImpExcelTool;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.StringJoiner;
import java.util.logging.Logger;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import javax.servlet.http.HttpSession;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DateUtil;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.usermodel.WorkbookFactory;
import psdi.mbo.MboRemote;
import psdi.mbo.MboSetRemote;
import psdi.security.ConnectionKey;
import psdi.server.MXServer;
import psdi.util.MXApplicationException;
import psdi.util.MXException;
import psdi.webclient.system.beans.DataBean;
import psdi.webclient.system.controller.MPFormData;
import psdi.webclient.system.session.WebClientSession;

public class ImportExcelForBatchUpdateJaasset extends DataBean {
  private static final Logger logger = Logger.getLogger(ja.webclient.beans.jaasset.ImportExcelForBatchUpdateJaasset.class.getName());
  
  private SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
  
  public static WebClientSession wcs;
  
  public static HttpSession mxSession;
  
  public static MboRemote mainMbo;
  
  public static MPFormData mpData;
  
  public void importExecute() throws Exception {
    SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
    try {
      wcs = this.clientSession;
      mpData = ImpExcelTool.getInstance().checkExcelType(wcs);
      mxSession = wcs.getRequest().getSession();
    } catch (RemoteException e) {
      throw new RuntimeException(e);
    } 
    if (null == mxSession.getAttribute("mxClientSession"))
      mxSession.setAttribute("mxClientSession", wcs); 
    if (this.app != null && this.app.getAppBean() != null)
      mxSession.setAttribute("appMainMbo", this.app.getAppBean().getMbo()); 
    mxSession.setAttribute("mpData", mpData);
    wcs.getResponse().setContentType("text/html; charset=UTF-8");
    mainMbo = (MboRemote)mxSession.getAttribute("appMainMbo");
    byte[] b = mpData.getFileOutputStream().toByteArray();
    InputStream ips = new ByteArrayInputStream(b);
    logger.info("创建Workbook");
    Workbook workBook = WorkbookFactory.create(ips);
    try {
      writeToDataBase(workBook);
      this.clientSession.showMessageBox(this.clientSession.getCurrentEvent(), "提示", "派单成功", 1);
    } catch (Exception e) {
      throw new MXApplicationException("导入失败", e.getMessage());
    } 
  }
  
  public void writeToDataBase(Workbook workBook) throws RemoteException, MXException {
    logger.info("开始执行设备台账导入");
    long sTime = System.currentTimeMillis();
    int[] ints = { 1 };
    List<List<String[]>> sheetList = importExcel(workBook, ints);
    logger.info("sheetList");
    List<String[]> rowList = sheetList.get(0);
    logger.info("sheetList.get(0)");
    Date date = new Date();
    logger.info("分割List 一万条保存一次");
    List<List<String[]>> skipList = new ArrayList<>();
    Integer MAX_SIZE = Integer.valueOf(10000);
    int limit = (rowList.size() + MAX_SIZE.intValue() - 1) / MAX_SIZE.intValue();
    Stream.<Integer>iterate(Integer.valueOf(0), n -> Integer.valueOf(n.intValue() + 1)).limit(limit).forEach(i -> skipList.add(rowList.stream().skip((i.intValue() * MAX_SIZE.intValue())).limit(MAX_SIZE.intValue()).collect(Collectors.toList())));
    logger.info("数据校验");
    logger.info("构建对象");
    StringJoiner assetNumJoiner = new StringJoiner("','");
    List<AssetDto> assetDtoList = new ArrayList<>();
    for (List<String[]> getRowList : skipList) {
      for (String[] cellValue : getRowList) {
        String assetNum = cellValue[0];
        String SERIALNUM = cellValue[1];
        String EQ3 = cellValue[2];
        String DESCRIPTION = cellValue[3];
        String DEVICETYPE = cellValue[4];
        String UDDK = cellValue[5];
        String SFSZSB = cellValue[6];
        String XH = cellValue[7];
        String SL = cellValue[8];
        String SCCJ = cellValue[9];
        String CCBH = cellValue[10];
        String SCRQ = cellValue[11];
        String DCRQ = cellValue[12];
        String SYSJ = cellValue[13];
        String YSSJ = cellValue[14];
        String ZGSJ = cellValue[15];
        String JALABLE = cellValue[16];
        String JARZRQ = cellValue[17];
        String LOCATION = cellValue[18];
        String GL = cellValue[19];
        String STATUS = cellValue[20];
        String XZRQ = cellValue[21];
        String BFRQ = cellValue[22];
        String ZL = cellValue[23];
        String WXCC = cellValue[24];
        String GLBM = cellValue[25];
        String SYBM = cellValue[26];
        String SYR = cellValue[27];
        String LB = cellValue[28];
        String JAFGZG = cellValue[29];
        String JAPRODZG = cellValue[30];
        if (StringUtils.isEmpty(assetNum))
          throw new MXApplicationException("提示", "设备编码不能为空！"); 
        if (StringUtils.isEmpty(SERIALNUM))
          throw new MXApplicationException("提示", "设备编码为：'" + assetNum + "',资产编码不能为空！"); 
        if (StringUtils.isEmpty(EQ3))
          throw new MXApplicationException("提示", "设备编码为：'" + assetNum + "',机台号不能为空！"); 
        if (StringUtils.isEmpty(DESCRIPTION))
          throw new MXApplicationException("提示", "设备编码为：'" + assetNum + "',设备名称不能为空！"); 
        if (StringUtils.isEmpty(DEVICETYPE))
          throw new MXApplicationException("提示", "设备编码为：'" + assetNum + "',设备种类不能为空！"); 
        if (StringUtils.isEmpty(UDDK))
          throw new MXApplicationException("提示", "设备编码为：'" + assetNum + "',端口不能为空！"); 
        if (StringUtils.isEmpty(SFSZSB))
          throw new MXApplicationException("提示", "设备编码为：'" + assetNum + "',是否是主设备不能为空！"); 
        assetNumJoiner.add(assetNum);
        String sfzsb = "是".equals(SFSZSB) ? "1" : "0";
        AssetDto assetDto = new AssetDto();
        assetDto.setAssetNum(assetNum);
        assetDto.setSERIALNUM(SERIALNUM);
        assetDto.setEQ3(EQ3);
        assetDto.setDESCRIPTION(DESCRIPTION);
        assetDto.setDEVICETYPE(DEVICETYPE);
        assetDto.setUDDK(UDDK);
        assetDto.setSFSZSB(sfzsb);
        assetDto.setXH(XH);
        assetDto.setSL(SL);
        assetDto.setSCCJ(SCCJ);
        assetDto.setCCBH(CCBH);
        assetDto.setSCRQ(SCRQ);
        assetDto.setDCRQ(DCRQ);
        assetDto.setSYSJ(SYSJ);
        assetDto.setYSSJ(YSSJ);
        assetDto.setBFRQ(ZGSJ);
        assetDto.setJALABLE(JALABLE);
        assetDto.setJARZRQ(JARZRQ);
        assetDto.setLOCATION(LOCATION);
        assetDto.setGL(GL);
        assetDto.setSTATUS(STATUS);
        assetDto.setXZRQ(XZRQ);
        assetDto.setBFRQ(BFRQ);
        assetDto.setZL(ZL);
        assetDto.setWXCC(WXCC);
        assetDto.setGLBM(GLBM);
        assetDto.setSYBM(SYBM);
        assetDto.setSYR(SYR);
        assetDto.setLB(LB);
        assetDto.setJAFGZG(JAFGZG);
        assetDto.setJAPRODZG(JAPRODZG);
        assetDtoList.add(assetDto);
      } 
    } 
    ConnectionKey key = MXServer.getMXServer().getDBManager().getSystemConnectionKey();
    Connection con = MXServer.getMXServer().getDBManager().getConnection(key);
    Statement st = null;
    ResultSet rs = null;
    PreparedStatement updateAssetSt = null;
    List<String> isExistAssetNumList = new ArrayList<>();
    try {
      String assetQuery = "SELECT ASSETNUM FROM ASSET WHERE ASSETNUM IN ('" + assetNumJoiner + "')";
      st = con.createStatement();
      rs = st.executeQuery(assetQuery);
      while (rs.next())
        isExistAssetNumList.add(rs.getString("ASSETNUM")); 
      MboSetRemote assetMboSet = MXServer.getMXServer().getMboSet("ASSET", MXServer.getMXServer().getSystemUserInfo());
      String updateAssetSql = "UPDATE ASSET SET SERIALNUM = ?,EQ3 = ?,DESCRIPTION = ?,DEVICETYPE = ?,\nUDDK = ?,SFSZSB = ?,XH = ?,SL = ?,SCCJ = ?,\nCCBH = ?,SCRQ = ?,DCRQ = ?,\nSYSJ = ?,YSSJ = ?, ZGSJ = ?,JALABLE = ?,JARZRQ = ?,LOCATION = ?,GL = ?,STATUS = ?,XZRQ = ?,\nBFRQ = ?,ZL = ?,WXCC = ?,GLBM = ?,SYBM = ?,SYR = ?,LB = ?,JAPRODZG = ?,JAFGZG = ? \nWHERE ASSETNUM = ?";
      updateAssetSt = con.prepareStatement(updateAssetSql);
      for (AssetDto assetDto : assetDtoList) {
        String assetNum = assetDto.getAssetNum();
        logger.info("assetDto:" + assetDto);
        if (isExistAssetNumList.contains(assetNum)) {
          logger.info("更新：" + assetNum);
          updateAssetSt.setString(1, assetDto.getSERIALNUM());
          updateAssetSt.setString(2, assetDto.getEQ3());
          updateAssetSt.setString(3, assetDto.getDESCRIPTION());
          updateAssetSt.setString(4, assetDto.getDEVICETYPE());
          updateAssetSt.setString(5, assetDto.getUDDK());
          updateAssetSt.setString(6, assetDto.getSFSZSB());
          updateAssetSt.setString(7, assetDto.getXH());
          updateAssetSt.setString(8, assetDto.getSL());
          updateAssetSt.setString(9, assetDto.getSCCJ());
          updateAssetSt.setString(10, assetDto.getCCBH());
          String scrq = assetDto.getSCRQ();
          Date scrqDate = StringUtils.isEmpty(scrq) ? null : new Date(this.simpleDateFormat.parse(scrq).getTime());
          updateAssetSt.setDate(11, scrqDate);
          String dcrq = assetDto.getDCRQ();
          Date dcrqDate = StringUtils.isEmpty(dcrq) ? null : new Date(this.simpleDateFormat.parse(dcrq).getTime());
          updateAssetSt.setDate(12, dcrqDate);
          String sysj = assetDto.getSYSJ();
          Date sysjDate = StringUtils.isEmpty(sysj) ? null : new Date(this.simpleDateFormat.parse(sysj).getTime());
          updateAssetSt.setDate(13, sysjDate);
          String yssj = assetDto.getYSSJ();
          Date yssjDate = StringUtils.isEmpty(yssj) ? null : new Date(this.simpleDateFormat.parse(yssj).getTime());
          updateAssetSt.setDate(14, yssjDate);
          String zgsj = assetDto.getZGSJ();
          Date zgsjDate = StringUtils.isEmpty(zgsj) ? null : new Date(this.simpleDateFormat.parse(zgsj).getTime());
          updateAssetSt.setDate(15, zgsjDate);
          updateAssetSt.setString(16, assetDto.getJALABLE());
          String jarzrq = assetDto.getJARZRQ();
          Date jarzrqDate = StringUtils.isEmpty(jarzrq) ? null : new Date(this.simpleDateFormat.parse(jarzrq).getTime());
          updateAssetSt.setDate(17, jarzrqDate);
          updateAssetSt.setString(18, assetDto.getLOCATION());
          updateAssetSt.setString(19, assetDto.getGL());
          updateAssetSt.setString(20, assetDto.getSTATUS());
          String xzrq = assetDto.getXZRQ();
          Date xzrqDate = StringUtils.isEmpty(xzrq) ? null : new Date(this.simpleDateFormat.parse(xzrq).getTime());
          updateAssetSt.setDate(21, xzrqDate);
          String bfrq = assetDto.getBFRQ();
          Date bfrqDate = StringUtils.isEmpty(bfrq) ? null : new Date(this.simpleDateFormat.parse(bfrq).getTime());
          updateAssetSt.setDate(22, bfrqDate);
          updateAssetSt.setString(23, assetDto.getZL());
          updateAssetSt.setString(24, assetDto.getWXCC());
          updateAssetSt.setString(25, assetDto.getGLBM());
          updateAssetSt.setString(26, assetDto.getSYBM());
          updateAssetSt.setString(27, assetDto.getSYR());
          updateAssetSt.setString(28, assetDto.getLB());
          updateAssetSt.setString(29, assetDto.getJAPRODZG());
          updateAssetSt.setString(30, assetDto.getJAFGZG());
          updateAssetSt.setString(31, assetDto.getAssetNum());
          updateAssetSt.addBatch();
        } else {
          logger.info("新增：" + assetNum);
          MboRemote assetMbo = assetMboSet.add();
          assetAdd(assetNum, assetMbo, assetDto);
        } 
        updateAssetSt.executeBatch();
        assetMboSet.save();
        assetMboSet.close();
      } 
    } catch (SQLException|java.text.ParseException e) {
      throw new RuntimeException(e);
    } finally {
      try {
        if (rs != null)
          rs.close(); 
        if (updateAssetSt != null)
          updateAssetSt.close(); 
        if (st != null)
          st.close(); 
        if (con != null)
          con.close(); 
      } catch (SQLException e) {
        throw new RuntimeException(e);
      } 
    } 
  }
  
  public void assetAdd(String assetNum, MboRemote assetMbo, AssetDto assetDto) throws RemoteException, MXException {
    assetMbo.setValue("ASSETNUM", assetNum, 11L);
    assetMbo.setValue("SERIALNUM", assetDto.getSERIALNUM(), 11L);
    assetMbo.setValue("EQ3", assetDto.getEQ3(), 11L);
    assetMbo.setValue("DESCRIPTION", assetDto.getDESCRIPTION(), 11L);
    assetMbo.setValue("DEVICETYPE", assetDto.getDEVICETYPE(), 11L);
    assetMbo.setValue("UDDK", assetDto.getUDDK(), 11L);
    assetMbo.setValue("SFSZSB", assetDto.getSFSZSB(), 11L);
    assetMbo.setValue("XH", assetDto.getXH(), 11L);
    assetMbo.setValue("SL", assetDto.getSL(), 11L);
    assetMbo.setValue("SCCJ", assetDto.getSCCJ(), 11L);
    assetMbo.setValue("CCBH", assetDto.getCCBH(), 11L);
    assetMbo.setValue("SCRQ", assetDto.getSCRQ(), 11L);
    assetMbo.setValue("DCRQ", assetDto.getDCRQ(), 11L);
    assetMbo.setValue("SYSJ", assetDto.getSYSJ(), 11L);
    assetMbo.setValue("YSSJ", assetDto.getYSSJ(), 11L);
    assetMbo.setValue("ZGSJ", assetDto.getZGSJ(), 11L);
    assetMbo.setValue("JALABLE", assetDto.getJALABLE(), 11L);
    assetMbo.setValue("JARZRQ", assetDto.getJARZRQ(), 11L);
    assetMbo.setValue("LOCATION", assetDto.getLOCATION(), 11L);
    assetMbo.setValue("GL", assetDto.getGL(), 11L);
    assetMbo.setValue("STATUS", assetDto.getSTATUS(), 11L);
    assetMbo.setValue("XZRQ", assetDto.getXZRQ(), 11L);
    assetMbo.setValue("BFRQ", assetDto.getBFRQ(), 11L);
    assetMbo.setValue("ZL", assetDto.getZL(), 11L);
    assetMbo.setValue("WXCC", assetDto.getWXCC(), 11L);
    assetMbo.setValue("GLBM", assetDto.getGLBM(), 11L);
    assetMbo.setValue("SYBM", assetDto.getSYBM(), 11L);
    assetMbo.setValue("SYR", assetDto.getSYR(), 11L);
    assetMbo.setValue("LB", assetDto.getLB(), 11L);
    assetMbo.setValue("JAPRODZG", assetDto.getJAPRODZG(), 11L);
    assetMbo.setValue("JAFGZG", assetDto.getJAFGZG());
  }
  
  public List<List<String[]>> importExcel(Workbook workBook, int[] sheetIndex) {
    int numberOfSheets = workBook.getNumberOfSheets();
    logger.info("不符合条件的下标剔除");
    List<Integer> sheetIndexList = new ArrayList<>();
    for (int i = 0; i < sheetIndex.length; i++) {
      if (sheetIndex[i] <= numberOfSheets)
        sheetIndexList.add(Integer.valueOf(sheetIndex[i])); 
    } 
    List<List<String[]>> sheetList = new ArrayList<>();
    logger.info("遍历shee页");
    for (int s = 0; s < numberOfSheets; s++) {
      logger.info("不需要读取的sheet页跳过");
      if (sheetIndexList.contains(Integer.valueOf(s + 1))) {
        logger.info("sheet页:" + s);
        List<String[]> rowList = (List)new ArrayList<>();
        Sheet sheet = workBook.getSheetAt(s);
        int rowCount = sheet.getPhysicalNumberOfRows();
        int physicalNumberOfCells = sheet.getRow(0).getLastCellNum();
        logger.info("获取sheet中有效的数据行:" + rowCount);
        logger.info("获取sheet中有效的数据行:" + physicalNumberOfCells);
        for (int j = 0; j < rowCount; j++) {
          if (j != 0) {
            logger.info("获取每一行得数据:" + j);
            Row row = sheet.getRow(j);
            if (row != null) {
              String[] objects = new String[physicalNumberOfCells];
              for (int k = 0; k < physicalNumberOfCells; k++) {
                logger.info("遍历单元格:" + k);
                Cell cell = row.getCell(k);
                String cellValueToString = convertCellValueToString(cell);
                logger.info("得到内容:" + cellValueToString);
                objects[k] = cellValueToString;
              } 
              rowList.add(objects);
            } 
          } 
        } 
        sheetList.add(rowList);
      } 
    } 
    return sheetList;
  }
  
  public String convertCellValueToString(Cell cell) {
    short dataFormat;
    boolean booleanCellValue;
    byte errorCellValue;
    if (cell == null)
      return null; 
    String cellValue = null;
    logger.info("cell.getCellType():" + cell.getCellType());
    switch (cell.getCellType()) {
      case 0:
        dataFormat = cell.getCellStyle().getDataFormat();
        System.out.println("获取单元格的格式:" + dataFormat);
        if (DateUtil.isCellDateFormatted(cell)) {
          SimpleDateFormat sdf = null;
          switch (dataFormat) {
            case 14:
              sdf = new SimpleDateFormat("yyyy-MM-dd");
              break;
            case 21:
              sdf = new SimpleDateFormat("HH:mm:ss");
              break;
            case 22:
              sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
              break;
          } 
          Date date = cell.getDateCellValue();
          assert sdf != null;
          cellValue = sdf.format(date);
          break;
        } 
        if (dataFormat == 0) {
          DecimalFormat df = new DecimalFormat("0");
          double numericCellValue = cell.getNumericCellValue();
          cellValue = df.format(numericCellValue);
        } 
        break;
      case 1:
        cellValue = cell.getStringCellValue();
        break;
      case 4:
        booleanCellValue = cell.getBooleanCellValue();
        cellValue = Boolean.toString(booleanCellValue);
        break;
      case 2:
        cellValue = cell.getCellFormula();
        break;
      case 5:
        errorCellValue = cell.getErrorCellValue();
        cellValue = Byte.toString(errorCellValue);
        break;
    } 
    return cellValue;
  }
}
